commit:     c412e2e33d097510f86880c5cb2d28fd7c2e7c97
Author:     Michał Górny <mgorny <AT> gentoo <DOT> org>
AuthorDate: Sat Mar  1 12:56:22 2025 +0000
Commit:     Michał Górny <mgorny <AT> gentoo <DOT> org>
CommitDate: Sat Mar  1 12:58:29 2025 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=c412e2e3

llvm-runtimes/flang-rt: Add 21.0.0_pre20250301 snapshot

Signed-off-by: Michał Górny <mgorny <AT> gentoo.org>

 llvm-runtimes/flang-rt/Manifest                    |  1 +
 .../flang-rt/flang-rt-21.0.0_pre20250301.ebuild    | 72 ++++++++++++++++++++++
 2 files changed, 73 insertions(+)

diff --git a/llvm-runtimes/flang-rt/Manifest b/llvm-runtimes/flang-rt/Manifest
index 72f84bf47289..c7fdddbe6ab3 100644
--- a/llvm-runtimes/flang-rt/Manifest
+++ b/llvm-runtimes/flang-rt/Manifest
@@ -1 +1,2 @@
+DIST llvm-project-7e8a06cfa4a2951b8ee77e19e34926e6e535b4d1.tar.gz 228792296 
BLAKE2B 
cd9357bdca9342770820f9fadfbd0b129a83324847f18e2ebac1fed8df4afb101aba2dc19d90264ae1e2d5692e34149ca24ef82a4973e7aeddb157268bb411b6
 SHA512 
9821a34a559e1db596940d76ce9388360baea43c1a9de814f567bfcf1428a0c6e3ced61b1e07537058454785d9c3aa3f443cbcf742a01fb40dd20b476a906442
 DIST llvm-project-d254fa877f419e61e54709f0a6f2e891da893a60.tar.gz 228028122 
BLAKE2B 
3321f3b205dfcd672d52122d7ba8e4e737916e01f5041a0dc140722f64359476632e036da0e0692cd366b080a073292cfdb4963e973bf800afabc20d06a2e86b
 SHA512 
135c4864973b682cf41953d43d977eaa219a4a898fceb4b4a8cacbbc6a5dd271d26010b1db6c6c90e761bf3495036f3e7528ab259d48c9c4dc4a064332c0326f

diff --git a/llvm-runtimes/flang-rt/flang-rt-21.0.0_pre20250301.ebuild 
b/llvm-runtimes/flang-rt/flang-rt-21.0.0_pre20250301.ebuild
new file mode 100644
index 000000000000..30245857a84e
--- /dev/null
+++ b/llvm-runtimes/flang-rt/flang-rt-21.0.0_pre20250301.ebuild
@@ -0,0 +1,72 @@
+# Copyright 1999-2025 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+inherit cmake flag-o-matic llvm.org
+
+DESCRIPTION="LLVM's Fortran runtime"
+HOMEPAGE="https://flang.llvm.org/";
+
+LICENSE="Apache-2.0-with-LLVM-exceptions"
+SLOT="${LLVM_MAJOR}"
+IUSE="+debug test"
+RESTRICT="!test? ( test )"
+
+RDEPEND="
+       !<llvm-core/flang-21.0.0_pre20250221-r1
+"
+BDEPEND="
+       llvm-core/llvm:${LLVM_MAJOR}
+       llvm-core/flang
+       test? (
+               dev-python/lit
+       )
+"
+
+LLVM_COMPONENTS=(
+       runtimes flang-rt cmake flang llvm/{cmake,utils/llvm-lit}
+)
+llvm.org_set_globals
+
+src_configure() {
+       # the code is not portable
+       local -x FC=flang F77=flang
+       strip-unsupported-flags
+
+       local mycmakeargs=(
+               # we may not have a runtime yet
+               -DCMAKE_Fortran_COMPILER_WORKS=TRUE
+
+               -DLLVM_ENABLE_RUNTIMES="flang-rt"
+               # this package forces NO_DEFAULT_PATHS
+               -DLLVM_BINARY_DIR="${ESYSROOT}/usr/lib/llvm/${LLVM_MAJOR}"
+
+               -DFLANG_RT_INCLUDE_TESTS=$(usex test)
+       )
+       use test && mycmakeargs+=(
+               -DLLVM_EXTERNAL_LIT="${EPREFIX}/usr/bin/lit"
+               -DLLVM_LIT_ARGS="$(get_lit_flags)"
+       )
+
+       # LLVM_ENABLE_ASSERTIONS=NO does not guarantee this for us, #614844
+       use debug || local -x CPPFLAGS="${CPPFLAGS} -DNDEBUG"
+       cmake_src_configure
+}
+
+src_test() {
+       # respect TMPDIR!
+       local -x LIT_PRESERVES_TMP=1
+       cmake_build check-flang-rt
+}
+
+src_install() {
+       cmake_src_install
+
+       # in standalone build, the library is installed to (incorrect) resource 
dir
+       # but the driver only looks for it in lib (sigh)
+       # https://github.com/llvm/llvm-project/issues/127538
+       mkdir -p "${ED}/usr/lib/llvm/${LLVM_MAJOR}" || die
+       mv "${ED}/usr/$(get_libdir)/clang/${LLVM_MAJOR}/lib"/* \
+               "${ED}/usr/lib/llvm/${LLVM_MAJOR}/lib" || die
+}

Reply via email to